/*******************************************************************************
* File Name: Measure_Mux.h
* Version 1.50
*
*  Description:
*    This file contains the constants and function prototypes for the Analog
*    Multiplexer User Module AMux.
*
*   Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_AMUX_Measure_Mux_H)
#define CY_AMUX_Measure_Mux_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cyfitter_cfg.h"


/***************************************
*        Function Prototypes
***************************************/

void Measure_Mux_Start(void);
void Measure_Mux_Init(void);
void Measure_Mux_Stop(void);
void Measure_Mux_Select(uint8 channel) ;
void Measure_Mux_FastSelect(uint8 channel) ;
void Measure_Mux_DisconnectAll(void) ;
/* The Connect and Disconnect functions are declared elsewhere */
/* void Measure_Mux_Connect(uint8 channel); */
/* void Measure_Mux_Disconnect(uint8 channel); */


/***************************************
*     Initial Parameter Constants
***************************************/

#define Measure_Mux_CHANNELS  2
#define Measure_Mux_MUXTYPE   1


/***************************************
*             API Constants
***************************************/

#define Measure_Mux_NULL_CHANNEL  0xFFu
#define Measure_Mux_MUX_SINGLE   1
#define Measure_Mux_MUX_DIFF     2


/***************************************
*        Conditional Functions
***************************************/

#if Measure_Mux_MUXTYPE == Measure_Mux_MUX_SINGLE
# define Measure_Mux_Connect(channel) Measure_Mux_Set(channel)
# define Measure_Mux_Disconnect(channel) Measure_Mux_Unset(channel)
#else
void Measure_Mux_Connect(uint8 channel) ;
void Measure_Mux_Disconnect(uint8 channel) ;
#endif

#endif /* CY_AMUX_Measure_Mux_H */


/* [] END OF FILE */
