/*******************************************************************************
* FILENAME: cyfitter_cfg.c
* PSoC Creator 2.2 Nightly Build 76
*
* Description:
* This file is automatically generated by PSoC Creator with device 
* initialization code.  Except for the user defined sections in
* CyClockStartupError(), this file should not be modified.
*
********************************************************************************
* Copyright 2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include <string.h>
#include <cytypes.h>
#include <cydevice_trm.h>
#include <cyfitter.h>
#include <CyLib.h>
#include <cyfitter_cfg.h>

/* Clock startup error codes                                                   */
#define CYCLOCKSTART_NO_ERROR    0
#define CYCLOCKSTART_XTAL_ERROR  1
#define CYCLOCKSTART_32KHZ_ERROR 2
#define CYCLOCKSTART_PLL_ERROR   3

/*******************************************************************************
* Function Name: CyClockStartupError
********************************************************************************
* Summary:
*  If an error is encountered during clock configuration (crystal startup error,
*  PLL lock error, etc) the system will end up here.  Unless reimplemented by 
*  the customer, an infinite loop will be encountered.
*
* Parameters:  
*   void
*
* Return:
*   void
*
*******************************************************************************/
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void CyClockStartupError(uint8 errorCode)
{
    /* To remove the compiler warning if errorCode not used.                */
    errorCode = errorCode;

    /* `#START CyClockStartupError` */

    /* `#END` */

    /* If nothing else, stop here since the clocks have not started         */
    /* correctly.                                                           */
    while(1) {}
}


#undef CYCODE
#undef CYDATA
#undef CYXDATA
#undef CYFAR
#if defined(__C51__) || defined(__CX51__)
	#define CYCODE code
	#define CYDATA data
	#define CYXDATA xdata
	#define CYFAR far

	#define CYPACKED
	#define CYALIGNED
    
	#define CY_CFG_MEMORY_BARRIER()

	#ifndef CYCONFIGCPY_DECLARED
		extern void cymemzero(void CYFAR *addr, uint16 size);
		extern void cyconfigcpy(uint16 size, const void CYFAR *src, void CYFAR *dest) small;
		extern void cyconfigcpycode(uint16 size, const void CYCODE *src, void CYFAR *dest);
	#endif


	#define CYMEMZERO(a,c) cymemzero((a),(c))
	#define CYCONFIGCPY(d,s,c) cyconfigcpy((c),(s),(d))
	#define CYCONFIGCPYCODE(d,s,c) cyconfigcpycode((c),(s),(d))
#else
	#error Unsupported toolchain
#endif

/* Defines the layout and meaning of each entry in the cfg_memset_list used for clearing registers */
typedef struct {
	void CYFAR *address;
	uint16 size;
} CYPACKED cfg_memset_t;

/* Defines the layout and meaning of each entry in the cfg_memcpy_list used for initializing registers */
typedef struct {
	void CYFAR *dest;
	const void CYCODE *src;
	uint16 size;
} CYPACKED cfg_memcpy_t;

/* Contains the regions of memory that must be set to 0 during configuration */
#define CFG_MEMSET_COUNT (sizeof(cfg_memset_list)/sizeof(*cfg_memset_list))
static const cfg_memset_t CYCODE cfg_memset_list [] = {
	/* address, size */
	{(void CYFAR *)(CYREG_TMR0_CFG0), 12},
	{(void CYFAR *)(CYREG_PRT4_DR), 48},
	{(void CYFAR *)(CYREG_PRT15_DR), 16},
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_U0_BASE), 4096},
	{(void CYFAR *)(CYDEV_UCFG_B1_P2_U0_BASE), 2048},
	{(void CYFAR *)(CYDEV_UCFG_DSI0_BASE), 2560},
	{(void CYFAR *)(CYDEV_UCFG_DSI12_BASE), 512},
	{(void CYFAR *)(CYREG_BCTL0_MDCLK_EN), 32},
};

const uint8 CYCODE cfg_byte_table[] = {
	0x1E,
	0x00, 0x4F, 0x02, /* Base address 0x004F00 */
	/* CYREG_TMR0_CFG0 */
	0x01, 0x80, 0x0A, 0x4B, 
	0x00, 0x52, 0x04, /* Base address 0x005200 */
	/* CYDEV_PRTDSI_PRT1_BASE */
	0x08, 0x40, 0x0C, 0x30, 
	/* CYDEV_PRTDSI_PRT12_BASE */
	0x60, 0x60, 0x61, 0x40, 
	0x00, 0x5A, 0x01, /* Base address 0x005A00 */
	/* CYREG_CMP0_SW0 */
	0xC7, 0x04, 
	0x00, 0x5B, 0x01, /* Base address 0x005B00 */
	/* CYREG_DSM0_SW0 */
	0x07, 0x04, 
	0x01, 0x03, 0x01, /* Base address 0x010300 */
	/* CYDEV_UCFG_B0_P1_ROUTE_BASE + 0x00000080 */
	0xE8, 0x04, 
	0x01, 0x07, 0x01, /* Base address 0x010700 */
	/* CYDEV_UCFG_B0_P3_ROUTE_BASE + 0x00000080 */
	0xEE, 0x08, 
	0x01, 0x09, 0x03, /* Base address 0x010900 */
	/* CYDEV_UCFG_B0_P4_ROUTE_BASE + 0x00000080 */
	0xA3, 0x80, 0xAF, 0x01, 0xB7, 0x02, 
	0x01, 0x0A, 0x20, /* Base address 0x010A00 */
	/* CYDEV_UCFG_B0_P5_U0_BASE */
	0x01, 0x11, 0x03, 0x06, 0x0C, 0x3A, 0x0E, 0x41, 0x0F, 0x03, 0x12, 0x2C, 0x14, 0x16, 0x15, 0x05, 
	0x16, 0x61, 0x17, 0x0A, 0x18, 0x2D, 0x1A, 0x50, 0x20, 0x80, 0x29, 0x04, 0x2B, 0x18, 0x2C, 0x03, 
	0x2F, 0x05, 0x31, 0x1F, 0x32, 0x1F, 0x34, 0x60, 0x36, 0x80, 0x38, 0x0A, 0x3A, 0x20, 0x3E, 0x41, 
	0x52, 0x01, 0x54, 0x01, 0x56, 0x10, 0x58, 0x04, 0x59, 0x04, 0x5B, 0x04, 0x5D, 0x90, 0x5F, 0x01, 
	0x01, 0x0B, 0x1B, /* Base address 0x010B00 */
	/* CYDEV_UCFG_B0_P5_ROUTE_BASE */
	0x00, 0x40, 0x08, 0x02, 0x0A, 0x18, 0x10, 0x02, 0x13, 0x02, 0x19, 0xA4, 0x1A, 0x18, 0x1B, 0x81, 
	0x20, 0x40, 0x21, 0x01, 0x28, 0x02, 0x29, 0x20, 0x31, 0x04, 0x39, 0x42, 0x59, 0x80, 0x68, 0x02, 
	0x69, 0x40, 
	/* CYDEV_UCFG_B0_P5_ROUTE_BASE + 0x00000080 */
	0x8A, 0x04, 0x98, 0x02, 0xB4, 0x04, 0xC0, 0x01, 0xC2, 0x0E, 0xC4, 0x09, 0xCA, 0x0C, 0xCC, 0x02, 
	0xCE, 0x09, 0xD6, 0x08, 
	0x01, 0x0C, 0x14, /* Base address 0x010C00 */
	/* CYDEV_UCFG_B0_P6_U0_BASE */
	0x52, 0x01, 0x56, 0x10, 0x5B, 0x04, 0x5D, 0x90, 0x5F, 0x01, 
	/* CYDEV_UCFG_B0_P6_U1_BASE */
	0x8E, 0x08, 0x96, 0x05, 0x9E, 0x02, 0xAC, 0x01, 0xAE, 0x02, 0xB2, 0x08, 0xB4, 0x03, 0xB6, 0x04, 
	0xBA, 0x0B, 0xBE, 0x10, 0xD6, 0x08, 0xD8, 0x04, 0xDB, 0x04, 0xDC, 0x08, 0xDF, 0x11, 
	0x01, 0x0D, 0x15, /* Base address 0x010D00 */
	/* CYDEV_UCFG_B0_P6_ROUTE_BASE */
	0x00, 0x40, 0x0A, 0x11, 0x11, 0x80, 0x18, 0x44, 0x1A, 0x11, 0x5B, 0x80, 0x60, 0x02, 0x6D, 0x80, 
	0x7A, 0x08, 
	/* CYDEV_UCFG_B0_P6_ROUTE_BASE + 0x00000080 */
	0x82, 0x10, 0x83, 0x80, 0x96, 0x01, 0xA2, 0x08, 0xAA, 0x08, 0xC0, 0x01, 0xC2, 0x05, 0xC4, 0x01, 
	0xD6, 0x08, 0xD8, 0x08, 0xDE, 0x04, 0xE0, 0x01, 
	0x01, 0x0F, 0x02, /* Base address 0x010F00 */
	/* CYDEV_UCFG_B0_P7_ROUTE_BASE + 0x00000080 */
	0x86, 0x01, 0xE0, 0x08, 
	0x01, 0x15, 0x01, /* Base address 0x011500 */
	/* CYDEV_UCFG_B1_P2_ROUTE_BASE + 0x00000080 */
	0xE8, 0x60, 
	0x01, 0x17, 0x01, /* Base address 0x011700 */
	/* CYDEV_UCFG_B1_P3_ROUTE_BASE + 0x00000080 */
	0xEC, 0x40, 
	0x01, 0x19, 0x04, /* Base address 0x011900 */
	/* CYDEV_UCFG_B1_P4_ROUTE_BASE + 0x00000080 */
	0x83, 0x80, 0xA3, 0x80, 0xE4, 0x04, 0xEC, 0x40, 
	0x01, 0x1B, 0x01, /* Base address 0x011B00 */
	/* CYDEV_UCFG_B1_P5_ROUTE_BASE + 0x00000080 */
	0xE8, 0x60, 
	0x01, 0x40, 0x04, /* Base address 0x014000 */
	/* CYDEV_UCFG_DSI0_BASE */
	0x10, 0x80, 0x3E, 0x40, 
	/* CYDEV_UCFG_DSI0_BASE + 0x00000080 */
	0xC4, 0x10, 0xCE, 0x20, 
	0x01, 0x41, 0x03, /* Base address 0x014100 */
	/* CYDEV_UCFG_DSI1_BASE + 0x00000080 */
	0x96, 0x40, 0xA8, 0x80, 0xE8, 0x20, 
	0x01, 0x42, 0x03, /* Base address 0x014200 */
	/* CYDEV_UCFG_DSI2_BASE */
	0x63, 0x02, 
	/* CYDEV_UCFG_DSI2_BASE + 0x00000080 */
	0x96, 0x40, 0xD6, 0x40, 
	0x01, 0x43, 0x06, /* Base address 0x014300 */
	/* CYDEV_UCFG_DSI3_BASE */
	0x19, 0x01, 0x1A, 0x40, 
	/* CYDEV_UCFG_DSI3_BASE + 0x00000080 */
	0x96, 0x40, 0xAF, 0x01, 0xC6, 0x10, 0xEE, 0x10, 
	0x01, 0x44, 0x08, /* Base address 0x014400 */
	/* CYDEV_UCFG_DSI4_BASE */
	0x2B, 0x08, 0x71, 0x02, 0x76, 0x40, 0x7F, 0x80, 
	/* CYDEV_UCFG_DSI4_BASE + 0x00000080 */
	0x86, 0x40, 0xCA, 0x08, 0xDC, 0x01, 0xDE, 0x05, 
	0x01, 0x45, 0x04, /* Base address 0x014500 */
	/* CYDEV_UCFG_DSI5_BASE + 0x00000080 */
	0x81, 0x02, 0xA3, 0x08, 0xA5, 0x02, 0xA7, 0x80, 
	0x01, 0x46, 0x0E, /* Base address 0x014600 */
	/* CYDEV_UCFG_DSI6_BASE */
	0x44, 0x10, 0x48, 0x02, 0x65, 0x80, 
	/* CYDEV_UCFG_DSI6_BASE + 0x00000080 */
	0x88, 0x01, 0x8B, 0x80, 0x99, 0x80, 0xA3, 0x08, 0xA7, 0x80, 0xB5, 0x80, 0xD0, 0x01, 0xD2, 0x08, 
	0xD6, 0x01, 0xE0, 0x01, 0xEC, 0x02, 
	0x01, 0x47, 0x07, /* Base address 0x014700 */
	/* CYDEV_UCFG_DSI7_BASE */
	0x64, 0x08, 
	/* CYDEV_UCFG_DSI7_BASE + 0x00000080 */
	0x9C, 0x10, 0xA0, 0x01, 0xA4, 0x02, 0xB7, 0x08, 0xD8, 0x01, 0xEA, 0x08, 
	0x01, 0x48, 0x04, /* Base address 0x014800 */
	/* CYDEV_UCFG_DSI8_BASE */
	0x21, 0x01, 0x24, 0x02, 
	/* CYDEV_UCFG_DSI8_BASE + 0x00000080 */
	0xB5, 0x01, 0xC8, 0x60, 
	0x01, 0x49, 0x02, /* Base address 0x014900 */
	/* CYDEV_UCFG_DSI9_BASE + 0x00000080 */
	0xB1, 0x01, 0xB4, 0x01, 
	0x01, 0x4C, 0x07, /* Base address 0x014C00 */
	/* CYDEV_UCFG_DSI12_BASE */
	0x67, 0x02, 
	/* CYDEV_UCFG_DSI12_BASE + 0x00000080 */
	0x83, 0x01, 0x9C, 0x18, 0xA0, 0x01, 0xB4, 0x02, 0xD6, 0x01, 0xEC, 0x02, 
	0x01, 0x4D, 0x06, /* Base address 0x014D00 */
	/* CYDEV_UCFG_DSI13_BASE */
	0x74, 0x01, 
	/* CYDEV_UCFG_DSI13_BASE + 0x00000080 */
	0xA0, 0x01, 0xB0, 0x10, 0xB4, 0x08, 0xDE, 0x04, 0xE8, 0x06, 
	0x01, 0x50, 0x07, /* Base address 0x015000 */
	/* CYREG_BCTL0_MDCLK_EN */
	0x00, 0x01, 0x01, 0x01, 0x02, 0x14, 0x0C, 0x01, 0x0D, 0x01, 0x0E, 0x01, 0x0F, 0x01, 
	0x01, 0x51, 0x01, /* Base address 0x015100 */
	/* CYREG_IDMUX_DRQ_CTL0 */
	0x10, 0x02, 
};
/* BYTES: 487 */

/* IOPINS0_0 Address: CYREG_PRT0_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_0_VAL[] = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFB, 0x00};

/* IOPINS0_1 Address: CYREG_PRT1_DR Size (bytes): 10 */
static const uint8 CYCODE BS_IOPINS0_1_VAL[] = {
	0x30, 0x00, 0x30, 0x70, 0x70, 0x00, 0x40, 0x00, 0x00, 0x00};

/* IOPINS0_7 Address: CYREG_PRT12_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_7_VAL[] = {
	0x00, 0x70, 0x70, 0x00, 0x70, 0x00, 0x00, 0x00};

/* IOPINS0_2 Address: CYREG_PRT2_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_2_VAL[] = {
	0x00, 0x7F, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00};

/* IOPINS0_3 Address: CYREG_PRT3_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_3_VAL[] = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00};


extern void cfg_write_bytes_code(void CYCODE *table);
extern void cfg_write_bytes(void CYFAR *table);

/*******************************************************************************
* Function Name: ClockSetup
********************************************************************************
*
* Summary:
*  Performs the initialization of all of the clocks in the device based on the
*  settings in the Clock tab of the DWR.  This includes enabling the requested
*  clocks and setting the necessary dividers to produce the desired frequency. 
*
* Parameters:
*  void
*
* Return:
*  void
*
*******************************************************************************/
static void ClockSetup(void)
{
	reg32  timeout;
	reg32* timeout_p = &timeout;
	reg8   pllLock;


	/* Configure Digital Clocks based on settings from Clock DWR */
	CY_SET_XTND_REG24((void CYFAR *)(CYREG_CLKDIST_DCFG0_CFG0), 0x180018);
	CY_SET_XTND_REG24((void CYFAR *)(CYREG_CLKDIST_DCFG1_CFG0), 0x18000C);

	/* Configure ILO based on settings from Clock DWR */
	CY_SET_REG8((void CYXDATA *)(CYREG_SLOWCLK_ILO_CR0), 0x02);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_CR), 0x08);

	/* Configure XTAL based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_XMHZ_CFG0), 0x3316);
	CY_SET_REG8((void CYXDATA *)(CYREG_FASTCLK_XMHZ_CSR), 0x01);
	/* Wait up to 130000us for the XTAL to lock */
	CY_GET_REG8(CYREG_FASTCLK_XMHZ_CSR);
	for (timeout = 130000 / 10; *timeout_p && (CY_GET_REG8(CYREG_FASTCLK_XMHZ_CSR) & 0x80u); timeout--) { 
		
		CyDelayCycles(10 * 48); /* Delay 10us based on 48MHz clock */
	}
	if (*timeout_p == 0)
		CyClockStartupError(CYCLOCKSTART_XTAL_ERROR);

	/* Configure PLL based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_P), 0x0B21);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_CR), 0x09);
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_CFG0), 0x1051);
	/* Wait up to 250us for the PLL to lock */
	pllLock = 0;
	for (timeout = 250 / 10; *timeout_p && (pllLock != 0x03u); timeout--) { 
		pllLock = 0x03u & ((pllLock << 1) | ((CY_GET_REG8(CYREG_FASTCLK_PLL_SR) & 0x01u) >> 0));
		CyDelayCycles(10 * 48); /* Delay 10us based on 48MHz clock */
	}

	/* Configure Bus/Master Clock based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x0100);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_CR), 0x49);

	/* Configure IMO based on settings from Clock DWR */
	CY_SET_REG8((void CYXDATA *)(CYREG_FASTCLK_IMO_CR), 0x20);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_MSTR0), 0x07);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_BCFG0), 0x00);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_BCFG2), 0x48);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_MSTR0), 0x00);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_LD), 0x02);

	CY_SET_REG8((void CYXDATA *)(CYREG_PM_ACT_CFG2), ((CY_GET_REG8(CYREG_PM_ACT_CFG2) | 0x03)));
}


/* Analog API Functions */


/*******************************************************************************
* Function Name: AnalogSetDefault
********************************************************************************
*
* Summary:
*  Sets up the analog portions of the chip to default values based on chip
*  configuration options from the project.
*
* Parameters:
*  void
*
* Return:
*  void
*
*******************************************************************************/
void AnalogSetDefault(void)
{
	uint8 bg_xover_inl_trim = CY_GET_XTND_REG8(CYREG_FLSHID_MFG_CFG_BG_XOVER_INL_TRIM + 1u);
	CY_SET_REG8(CYREG_BG_DFT0, bg_xover_inl_trim & 0x07u);
	CY_SET_REG8(CYREG_BG_DFT1, (bg_xover_inl_trim >> 4) & 0x0Fu);
	CY_SET_REG8(CYREG_PRT0_AG, 0x91);
	CY_SET_REG8(CYREG_BG_CR0, 0x0E);
	CY_SET_REG8(CYREG_DAC0_SW3, 0x80);
	CY_SET_REG8(CYREG_CMP0_SW0, 0x10);
	CY_SET_REG8(CYREG_CMP0_SW3, 0x40);
	CY_SET_REG8(CYREG_DSM0_SW0, 0x10);
	CY_SET_REG8(CYREG_DSM0_SW4, 0x80);
	CY_SET_REG16(CYREG_OPAMP0_MX, 0x0205);
	CY_SET_REG16(CYREG_OPAMP2_MX, 0x0205);
	CY_SET_REG8(CYREG_PUMP_CR0, 0x44);
}


/*******************************************************************************
* Function Name: SetAnalogRoutingPumps
********************************************************************************
*
* Summary:
* Enables or disables the analog pumps feeding analog routing switches.
* Intended to be called at startup, based on the Vdda system configuration;
* may be called during operation when the user informs us that the Vdda voltage crossed the pump threshold.
*
* Parameters:
*  enabled - 1 to enable the pumps, 0 to disable the pumps
*
* Return:
*  void
*
*******************************************************************************/
void SetAnalogRoutingPumps(uint8 enabled)
{
	uint8 regValue = CY_GET_REG8(CYREG_PUMP_CR0);
	if (enabled)
		regValue |= 0x22;
	else
		regValue &= ~0x22;
	CY_SET_REG8(CYREG_PUMP_CR0, regValue);
}

#define CY_AMUX_UNUSED CYREG_BOOST_SR
/* Table used to specify registers used to implement Measure_Mux */
uint8 CYXDATA * const CYCODE Measure_Mux__addrTable[] = {
	(uint8 CYXDATA *)CYREG_PRT0_AG, 
	(uint8 CYXDATA *)CYREG_PRT0_AG, 
};

/* Table used to define bit masks used to enable inputs for Measure_Mux */
const uint8 CYCODE Measure_Mux__maskTable[] = {
	0x10, 
	0x01, 
};

/*******************************************************************************
* Function Name: Measure_Mux_Set
********************************************************************************
* Summary:
*  This function is used to set a particular channel as active on the AMux.
*
* Parameters:  
*   channel - The mux channel input to set as active
*
* Return:
*   void
*
*******************************************************************************/
void Measure_Mux_Set(uint8 channel)
{
	if (channel >= 2)
		return;
	*Measure_Mux__addrTable[channel] |= Measure_Mux__maskTable[channel];
}

/*******************************************************************************
* Function Name: Measure_Mux_Unset
********************************************************************************
* Summary:
*  This function is used to clear a particular channel from being active on the
*  AMux.
*
* Parameters:  
*   channel - The mux channel input to mark inactive
*
* Return:
*   void
*
*******************************************************************************/
void Measure_Mux_Unset(uint8 channel)
{
	if (channel >= 2)
		return;
	*Measure_Mux__addrTable[channel] &= ~Measure_Mux__maskTable[channel];
}



/*******************************************************************************
* Function Name: cyfitter_cfg
********************************************************************************
* Summary:
*  This function is called by the start-up code for the selected device. It
*  performs all of the necessary device configuration based on the design
*  settings.  This includes settings from the Design Wide Resources (DWR) such
*  as Clocks and Pins as well as any component configuration that is necessary.
*
* Parameters:  
*   void
*
* Return:
*   void
*
*******************************************************************************/
void cyfitter_cfg(void)
{

	/* Set Flash Cycles based on max possible frequency in case a glitch occurs during ClockSetup(). */
	CY_SET_REG8((void CYXDATA *)(CYREG_CACHE_CR), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0xF1 : 0xC0));
	/* Setup clocks based on selections from Clock DWR */
	ClockSetup();
	/* Enable/Disable Debug functionality based on settings from System DWR */
	CY_SET_XTND_REG8(CYREG_MLOGIC_DEBUG, (CY_GET_XTND_REG8(CYREG_MLOGIC_DEBUG) | 0x05));

	{
		uint8 CYDATA i;

		/* Zero out critical memory blocks before beginning configuration */
		for (i = 0; i < CFG_MEMSET_COUNT; i++)
		{
			const cfg_memset_t CYCODE * CYDATA ms = &cfg_memset_list[i];
			CYMEMZERO(ms->address, ms->size);
		}

		cfg_write_bytes_code(cfg_byte_table);

		/* Perform normal device configuration. Order is not critical for these items. */
		CY_SET_XTND_REG16((void CYFAR *)(CYREG_LUT0_CR), 0x0003);
		CYMEMZERO((void CYFAR *)(CYREG_PHUB_CFGMEM0_CFG0), 4);

		/* Enable digital routing */
		CY_SET_XTND_REG8(CYREG_BCTL0_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL0_BANK_CTL) | 0x02u);
		CY_SET_XTND_REG8(CYREG_BCTL1_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL1_BANK_CTL) | 0x02u);

		/* Enable UDB array */
		CY_SET_REG8(CYREG_PM_ACT_CFG0, CY_GET_REG8(CYREG_PM_ACT_CFG0) | 0x40u);
		CY_SET_REG8(CYREG_PM_AVAIL_CR2, CY_GET_REG8(CYREG_PM_AVAIL_CR2) | 0x10u);
	}

	/* Perform second pass device configuration. These items must be configured in specific order after the regular configuration is done. */
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT0_DM0), (void CYCODE *)(BS_IOPINS0_0_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT1_DR), (void CYCODE *)(BS_IOPINS0_1_VAL), 10);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT12_DM0), (void CYCODE *)(BS_IOPINS0_7_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT2_DM0), (void CYCODE *)(BS_IOPINS0_2_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT3_DM0), (void CYCODE *)(BS_IOPINS0_3_VAL), 8);
	CY_SET_REG8((void CYXDATA *)(CYREG_INTC_CSR_EN), 0x01);

	/* Switch Boost to the precision bandgap reference from its internal reference */
	CY_SET_REG8(CYDEV_BOOST_CR2, (CY_GET_REG8(CYDEV_BOOST_CR2) | 0x08));
	if (CYDEV_CHIP_REV_ACTUAL < 5)
	{
		CY_SET_REG8(CYDEV_MFGCFG_PWRSYS_WAKE_TR2, 0x3A);
	}

	CY_SET_XTND_REG8((void CYFAR *)(CYREG_BCTL0_UDB_TEST_3), 0x40);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_BCTL1_UDB_TEST_3), 0x40);

	/* Perform basic analog initialization to defaults */
	AnalogSetDefault();

	/* Configure alternate active mode */
	CYCONFIGCPY((void CYFAR *)CYDEV_PM_STBY_BASE, (void CYFAR *)CYDEV_PM_ACT_BASE, 14);
	CY_SET_REG8(CYREG_PM_STBY_CFG0, CY_GET_REG8(CYREG_PM_STBY_CFG0) & ~0x02u);	/* Disable CPU */
}
